/* MARCH Satisfiability Solver

   Copyright (C) 2001-2004 M. Dufour, M. Heule, J. van Zwieten
   [m.dufour@student.tudelft.nl, marijn@heule.nl, zwieten@ch.tudelft.nl]

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __ROOTLOOK_H__
#define __ROOTLOOK_H__

#include "common.h"

void print_binary_all_equal();
void print_ternary_all_equal();

int root_iterative_lookahead();

int root_subsume();

int root_lookahead_literal( int nrval, int **_Vc, int **_qVc );
int root_iterative_unit_propagation( int nrval, int **_Vc, int **_qVc );
void root_clause_instantiation( int clsidx, int **_Vc, int **_qVc );

int root_add_constraint_resolvent( int nrval, int literal );

inline int  root_reduce_ternary_clauses( const int nrval, const int current );
int  root_reduce_equivalences();
int  root_reduce_long_clauses( int nrval, int *_qVc );

void root_subsume_ternary_clauses( int nrval, int *__Vc );
void root_find_new_equivalences( int nrval, int *__Vc );

int root_fix_forced_literal( int nrval, int **_Vc);
int root_find_na( int nrval, int **_Vc );
int root_propagate_unary_clauses();

int  root_fix_binary_implications( int nrval );

int AddTernaryResolvents();

int rootlook();
void cleanBinaryImp();
void fix_monotone();
int singlelook();

#endif
